<?php

declare(strict_types=1);

namespace Seka\Portal\modul\Statistiky\Tests\Unit\Entities\Zaznam\ValueObjects;

use InvalidArgumentException;
use Seka\Portal\Modul\Statistiky\Tests\TestCase;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\HodnotenieEmisnejKontrolyEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaDruhu;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaDruhuAHodnotenia;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\ZoznamPoctuKontrolPodlaDruhuAHodnotenia;

/**
 * Class ZoznamPoctuKontrolPodlaDruhuAHodnoteniaTest
 *
 * @package Seka\Portal\modul\Statistiky\Tests\Unit\Entities\Zaznam\ValueObjects
 */
class ZoznamPoctuKontrolPodlaDruhuAHodnoteniaTest extends TestCase
{
    /**
     *
     */
    public function testInstance()
    {
        $zoznam = new ZoznamPoctuKontrolPodlaDruhuAHodnotenia();

        self::assertInstanceOf(ZoznamPoctuKontrolPodlaDruhuAHodnotenia::class, $zoznam);
    }

    /**
     *
     */
    public function testAddInstanciaInejTriedy()
    {
        $zoznam = new ZoznamPoctuKontrolPodlaDruhuAHodnotenia();

        self::expectException(InvalidArgumentException::class);

        $zoznam->add(new PocetKontrolPodlaDruhu(
            DruhEmisnejKontrolyEnum::PRAVIDELNA(),
            11
        ));
    }

    /**
     *
     */
    public function testAddRovnakyDruhKontrolyARovnakeHodnotenia()
    {
        $zoznam = new ZoznamPoctuKontrolPodlaDruhuAHodnotenia();

        for ($a = 0; $a < 3; ++$a) {
            $pocetKontrolPodlaDruhuAHodnotenia = new PocetKontrolPodlaDruhuAHodnotenia(
                DruhEmisnejKontrolyEnum::PRAVIDELNA(),
                HodnotenieEmisnejKontrolyEnum::SPOSOBILE(),
                33
            );

            $zoznam->add($pocetKontrolPodlaDruhuAHodnotenia);
        }

        self::assertCount(1, $zoznam);
    }

    /**
     *
     */
    public function testAddRovnakyDruhKontrolyARozneHodnotenia()
    {
        $zoznam = new ZoznamPoctuKontrolPodlaDruhuAHodnotenia();

        for ($a = 0; $a < 4; ++$a) {
            $pocetKontrolPodlaDruhuAHodnotenia = new PocetKontrolPodlaDruhuAHodnotenia(
                DruhEmisnejKontrolyEnum::PRAVIDELNA(),
                HodnotenieEmisnejKontrolyEnum::make(HodnotenieEmisnejKontrolyEnum::toValues()[$a]),
                rand(1, 10)
            );

            $zoznam->add($pocetKontrolPodlaDruhuAHodnotenia);
        }

        self::assertCount(4, $zoznam);
    }

    /**
     *
     */
    public function testAddRoznyDruhKontrolyARovnakeHodnotenia()
    {
        $zoznam = new ZoznamPoctuKontrolPodlaDruhuAHodnotenia();

        for ($a = 0; $a < 7; ++$a) {
            $pocetKontrolPodlaDruhuAHodnotenia = new PocetKontrolPodlaDruhuAHodnotenia(
                DruhEmisnejKontrolyEnum::make(DruhEmisnejKontrolyEnum::toValues()[$a]),
                HodnotenieEmisnejKontrolyEnum::SPOSOBILE(),
                rand(1, 10)
            );

            $zoznam->add($pocetKontrolPodlaDruhuAHodnotenia);
        }

        self::assertCount(7, $zoznam);
    }

    /**
     *
     */
    public function testAddRoznyDruhKontrolyARozneHodnotenia()
    {
        $zoznam = new ZoznamPoctuKontrolPodlaDruhuAHodnotenia();

        for ($a = 0; $a < 4; ++$a) {
            $pocetKontrolPodlaDruhuAHodnotenia = new PocetKontrolPodlaDruhuAHodnotenia(
                DruhEmisnejKontrolyEnum::make(DruhEmisnejKontrolyEnum::toValues()[$a]),
                HodnotenieEmisnejKontrolyEnum::make(HodnotenieEmisnejKontrolyEnum::toValues()[$a]),
                rand(1, 10)
            );

            $zoznam->add($pocetKontrolPodlaDruhuAHodnotenia);
        }

        self::assertCount(4, $zoznam);
    }
}
